"""
 *****************************************************
 * ServSecurity 0.9                                  *
 * By ServSecurity Team - WWW.SERVSECURITY.COM       *
 * ***************************************************
 * This work is licensed under the Creative Commons  *
 * Attribution-Noncommercial-Share Alike 3.0         *
 * Unported License. To view a copy of this license, *
 * visit                                             *
 * http://creativecommons.org/licenses/by-nc-sa/3.0/ *
 * or send a letter to Creative Commons, 171 Second  *
 * Street, Suite 300, San Francisco, California,     *
 * 94105, USA.                                       *
 *****************************************************
"""

import es
import os
import sys
import time
import random
import repeat
import socket
import urllib
import shutil
import cPickle
import hashlib
import datetime
import threading
import gamethread

import update
reload(update)
from configobj import ConfigObj

import psyco
psyco.full()

info            = es.AddonInfo()
info.name       = 'ServSecurity'
info.version    = '0.9 beta 5'
info.basename   = 'servsecurity'
info.author     = 'Dark Session'
info.url        = 'http://servsecurity.com/'
info.build      = 143

es.ServerVar('servsecurity_version', info.version, 'Powerful script by Dark Session to prevent server lags, hacking attemps, abuse and crashes').makepublic()
es.ServerVar('servsecurity_build', info.build, 'ServSecurity build')

# Don't steal this list or future releases of ServSecurity will be encrypted!
CommandList =                               {
                                            "_restart": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "ai_debug_node_connect": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "ai_drop_hint": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "ai_dump_hints": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "ai_set_move_height_epsilon": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "async_resume": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "async_suspend": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "bind": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "bind_mac": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "BindToggle": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "budget_toggle_group": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "cache_print": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "cache_print_lru": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "cache_print_summary": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "changelevel2": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "clear_debug_overlays": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "cmd": {
                                                'flags': ['rm'],
                                                'side': ['server','client']
                                                },
                                            "commentary_cvarsnotchanging": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "commentary_finishnode": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "creditsdone": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "dbghist_addline": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "dbghist_dump": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "devshots_nextmap": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "differences": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "disconnect": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "dti_flush": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "dump_entity_sizes": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "dump_globals": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "dumpentityfactories": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "dumpeventqueue": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "dumpgamestringtable": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "dumpstringtables": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "es_version": {
                                                'flags': ['rm'],
                                                'side': ['client','server']
                                                },
                                            "explode": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "exit": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "fs_printopenfiles": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "groundlist": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "hammer_update_entity": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "hammer_update_safe_entities": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "heartbeat": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "host_runofftime": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "incrementvar": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "kdtree_test": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "key_findbinding": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "key_listboundkeys": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "listmodels": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "listmodels": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "listRecentNPCSpeech": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "nextmap": {
                                                'flags': ['rm','bl'],
                                                'side': ['server','client']
                                                },
                                            "ma_favourites": {
                                                'flags': ['rm','bl'],
                                                'side': ['server','client']
                                                },
                                            "ma_map": {
                                                'flags': ['rm','bl'],
                                                'side': ['server','client']
                                                },
                                            "ma_nextmap": {
                                                'flags': ['rm','bl'],
                                                'side': ['server','client']
                                                },
                                            "ma_showrestrict": {
                                                'flags': ['rm','bl'],
                                                'side': ['server','client']
                                                },
                                            "ma_showsounds": {
                                                'flags': ['rm','bl'],
                                                'side': ['server','client']
                                                },
                                            "ma_timeleft": {
                                                'flags': ['rm','bl'],
                                                'side': ['server','client']
                                                },
                                            "ma_version": {
                                                'flags': ['rm','bl'],
                                                'side': ['server','client']
                                                },
                                            "mat_configcurrent": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mat_hdr_enabled": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mat_info": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mat_savechanges": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mat_showmaterials": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mat_showmaterialsverbose": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mat_showtextures": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mem_compact": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mem_dump": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "mem_eat": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mem_test": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mem_vcollide": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "memory": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "mission_list": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mission_show": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mp_dump_timers": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "mp_scrambleteams": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mp_switchteams": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "mp_tournament_restart": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "multvarf": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "net_channels": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "net_start": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "net_status": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "phys_swap": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "physics_constraints": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "physics_debug_entity": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "physics_highlight_active": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "physics_report_active": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "physics_select": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "quit": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "r_3dnow": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "r_flushlod": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "r_printdecalinfo": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "r_sse2": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "reload": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "report_entities": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "report_simthinklist": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "report_soundpatch": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "report_touchlinks": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "restart": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "rr_reloadresponsesystems": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "scene_flush": {
                                                'flags': ['rm'],
                                                'side': ['server']
                                                },
                                            "server_game_time": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "skip_next_map": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "snd_restart": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "soundscape_flush": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "sv_benchmark_force_start": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "star_memory": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "sv_precacheinfo": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "sv_querycache_stats": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "thread_test_tslist": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "thread_test_tsqueue": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "threadpool_cycle_reserve": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "threadpool_run_tests": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "toggle": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "timeleft": {
                                                'flags': ['rm', 'bl'],
                                                'side': ['server','client']
                                                },
                                            "unbind": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "unbind_mac": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "unbindall": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "user": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "users": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vehicle_flushscript": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_cachemiss": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_cachemiss_off": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_cachemiss_on": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_counters": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_dump_groupnames": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_generate_report": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_generate_report_AI": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_generate_report_AI_only": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_generate_report_hierarchy": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_generate_report_map_load": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_off": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_on": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_playback_average": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_playback_start": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_playback_step": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_playback_stepback": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_playback_stop": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_record_start": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_record_stop": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_reset": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_reset_peaks": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                },
                                            "vprof_vtune_group": {
                                                'flags': ['bl'],
                                                'side': ['server']
                                                }}

ForbiddenUsernames =                        [
                                            "",
                                            "0",
                                            "unconnected",
                                            "empty"
                                            ]


PluginVerURL                                = "http://servsecurity.com/servsecurity/0.9/plugins.php"
GlobalIPList                                = "http://servsecurity.com/servsecurity/global_ipbanlist.php"
GlobalIDList                                = "http://servsecurity.com/servsecurity/global_idbanlist.php"
CheckPlayerVarDownloadURL                   = 'http://servsecurity.com/servsecurity/0.9/playervars.php'
ReportURL                                   = 'http://servsecurity.com/servsecurity/0.9/report.php'
# ASCII chars number 0 - 31: http://forums.eventscripts.com/viewtopic.php?p=328838#p328838
ForbiddenChars                              = map(lambda x: chr(x), range(0,32))
LastDBWrite                                 = time.time()
ConnectWhitelist                            = ["BOT", "STEAM_ID_LAN"]
IPWhitelist                                 = ['127.0.0.1', 'localhost', 'none']
LogWriteLimit                               = 10240 # 10kb
MaxUsernameLength                           = 32
GlobalBanListLastDownload                   = 0
CheckPlayerVarsLastDownload                 = 0
Loaded                                      = False
PreLoad                                     = False
Wrap                                        = os.linesep
LogfilePointer                              = None
UniqueID                                    = ""
LastUpdateCheck                             = 0
LastPluginCheck                             = 0
QueryClientVarThreadRunning                 = False
_AllowUnload                                = False
_Password                                   = ""
_UnauthorizedUnload                         = False
_LastUnautorizedUnload                      = False
TempLogWrite                                = ""
PS                                          = str(os.sep)

ProtectServerVars = {
        # Example:
        # 'ServerVar':                      {'default': 'Default Variable', 'cheatflag': 'Set cheatflag? 1 = yes, 0 = no', 'unload_remove_cheatflag': 'Remove cheatflag on unload? 1 = yes, 0 = no', 'hidevalue': 'Hide value on change message. 1 = yes, 0 = no', 'protected': 'Adds protected-flag to cvar. 1 = yes, 0 = no', 'loglevel': 'Loglevel when cvar changes'}
        'eventscripts_protectrcon':         {'default': '1', 'cheatflag': 1, 'unload_remove_cheatflag': 1},
        'rcon_password':                    {'default': '_request_', 'requestfile': '_cfgfile_', 'hidevalue': 1, 'protected': 1},
        'sv_cheats':                        {'default': '0', 'cheatflag': 1, 'unload_remove_cheatflag': 1},
        'sv_rcon_log':                      {'default': '1', 'cheatflag': 1, 'unload_remove_cheatflag': 1},
        #'sv_allow_wait_command':            {'default': '0', 'loglevel': 3}
    }

Config = {
        'block_connection_spam':            1,
        'block_usernames':                  1,
        'min_username_length':              2,
        'kick_unnamed':                     1,
        'maxconnectionsperip':              5,
        'ipbantime':                        (3600*24),
        'steamidbantime':                   (3600*24),
        'protectvars':                      1,
        'commandblocker':                   1,
        'steamid_pending_kick':             1,
        'steamid_pending_kick_time':        5,
        'block_text_with_illegal_chars':    1,
        'illegal_chars_max_tries':          5,
        'crashreporter':                    1,
        'timeformat':                       2,
        'kick_unassigned':                  1,
        'loglevel':                         3,
        'logtype':                          3,
        'one_logfile':                      0,
        'message_on_connect':               1,
        'use_global_ipbanlist':             1,
        'use_global_idbanlist':             1,
        'kick_clientside_addons':           1,
        'file_with_server_variables':       'server.cfg',
        'block_custom_disconnect_messages': 1,
        'autoupdate':                       1,
        'antinamehacks':                    1,
        'bancommand':                       'banid $length $steamid',
        'ping_limit':                       3,
        'status_limit':                     3,
        'check_cvars_sv_cheats':            1,
        #'check_cvars_sv_allow_wait_command':1,
        'say_delay':                        0.01,
        'allow_steamid_submit':             1,
        'client_check_cheat_cvars':         1,
    }

ClientCheckCheatCVars                       = {
                                                "host_framerate": 0,
                                                "host_timescale": 1.0,
                                                "r_drawothermodels": 1,
                                                "mat_wireframe": 0,
                                                "r_drawparticles": 1,
                                                "mat_fillrate": 0,
                                                "r_drawsprites": 1,
                                                "r_drawstaticprops": 1,
                                                "r_drawbrushmodels": 1,
                                                "r_drawrenderboxes": 0,
                                                "r_visualizelighttraces": 0,
                                                "mat_luxels": 0,
                                                "mat_measurefillrate": 0,
                                                "mat_fillrate": 0,
                                                "mat_yuv": 0,
                                                "adsp_duct_min": 106,
                                                "adsp_courtyard_min": 126,
                                                "adsp_hall_min": 110
                                            }

Statistics = {}
Statistics['KickedUsers']                    = 0
Statistics['BannedIPs']                      = 0
Statistics['BannedIDs']                      = 0
Statistics['BlockedText']                    = 0
Statistics['BlockedUsernames']               = 0
Statistics['BlockedCommands']                = 0
Statistics['BlockedCommandExecution']        = 0
Statistics['UnauthorizedUnloads']            = 0
Statistics['ResettedVariables']              = 0
Statistics['ReportedCrashes']                = 0
Statistics['BlockedConnectionFlooders']      = 0
Statistics['GlobalBannedIDs']                = 0
Statistics['GlobalBannedIPs']                = 0
Statistics['BlockedPingCommand']             = 0
Statistics['BlockedStatusCommand']           = 0

StatisticsText                               = {}
StatisticsText['KickedUsers']                = "Kicked users"
StatisticsText['BannedIPs']                  = "Banned IPs"
StatisticsText['BannedIDs']                  = "Banned Steam-IDs"
StatisticsText['BlockedText']                = "Blocked text"
StatisticsText['BlockedUsernames']           = "Blocked usernames"
StatisticsText['BlockedCommands']            = "Blocked commands (CMD-Filter)"
StatisticsText['BlockedCommandExecution']    = "Blocked execution of removed commands"
StatisticsText['UnauthorizedUnloads']        = "Unauthorized unloads attemps"
StatisticsText['ResettedVariables']          = "Resetted variables"
StatisticsText['ReportedCrashes']            = "Reported crashes"
StatisticsText['BlockedConnectionFlooders']  = "Blocked connection flooders"
StatisticsText['GlobalBannedIDs']            = "Kicked users with global banned Steam-IDs"
StatisticsText['GlobalBannedIPs']            = "Kicked users with global banned ips"

StatisticsTextOrder                          = [
                                                'KickedUsers',
                                                'BannedIPs',
                                                'BannedIDs',
                                                'BlockedText',
                                                'BlockedUsernames',
                                                'BlockedCommands',
                                                'BlockedCommandExecution',
                                                'UnauthorizedUnloads',
                                                'ResettedVariables',
                                                'ReportedCrashes',
                                                'BlockedConnectionFlooders',
                                                'GlobalBannedIDs',
                                                'GlobalBannedIPs']

def load():
    global Loaded, PreLoad, _AllowUnload, _LastUnautorizedUnload, UniqueID
    if Loaded:
        es.server.printmsg("[ServSecurity] ServSecurity already loaded!")
        return

    PreLoad = True

    SetVariables(1)

    for variable in Config:
        es.ServerVar("servsecurity_" + variable, Config[variable], 'ServSecurity config variable')

    Log(4, "Registriere Commands...")
    es.regcmd('servsecurity_updatecheck', 'servsecurity/Check4Updates', 'ServSecurity: Check for new ServSecurity version (duration: up to 15 minutes)')
    es.regcmd('servsecurity_forceupdate', 'servsecurity/ForceUpdate', 'ServSecurity: Force update (causes lags! duration: up to 30 seconds)')
    es.regcmd('servsecurity_unload', 'servsecurity/UnloadMe', 'ServSecurity: Unload ServSecurity (password required) - Usage: servsecurity_unload <ServSecurity password>')
    es.regcmd('servsecurity_setpassword', 'servsecurity/SetPassword', 'ServSecurity: Set ServSecurity password - Usage: servsecurity_setpassword <password>')
    es.regcmd('servsecurity_checkplugins', 'servsecurity/CheckPlugins', 'ServSecurity: Are your server plugins up-to-date?')
    es.regcmd('servsecurity_statistics', 'servsecurity/ShowStats', 'ServSecurity: Show statistics')

    Log(4, "Fuehre servsecurity.cfg aus")
    ExecCMD("exec servsecurity", 0)

    Log(4, "Setze Versions-Variable")
    es.setinfo('servsecurity_version', info.version)
    es.setinfo('servsecurity_build', info.build)

    Log(4, "Lese servsecurity.db")
    ReadVars(1)

    if len(UniqueID) == 0:
        UniqueID = str(hashlib.md5(str(random.randint(10000000,200000000))).hexdigest())[8:24]

    Log(4, "Lese Config ein")
    for variable in Config:
        Config[variable] = str(es.ServerVar("servsecurity_" + variable))

    if CFGVar('commandblocker') == 1:
        Log(4, "Blocke Commands...")
        for Command in CommandList:
            Flags = CommandList[Command]['flags']
            Side = CommandList[Command]['side']
            if 'rm' in Flags:
                if 'server' in Side:
                    Log(4, "RegCMD " + Command)
                    es.regcmd(Command, 'servsecurity/bannedservercmd')
                if 'client' in Side:
                    Log(4, "RegClientCMD " + Command)
                    es.regclientcmd(Command, 'servsecurity/bannedservercmd')
            if 'bl' in Flags:
                es.flags('add', 'cheat', Command)

    if CFGVar('block_text_with_illegal_chars'):
        Log(4, "Registriere Say-Filer")
        es.addons.registerSayFilter(sayFilter)

    DisableRCONCrashExploit(1)

    Log(4, "Starte Repeat fuer Diverses...")
    repeat.create('servsecurity_miscbackground', MiscBackground, (1)).start(2, 0)

    if CFGVar('block_connection_spam'):
        Log(4, "Starte Repeater zum zuruecksetzen der Verbindungs-Variablen")
        repeat.create('servsecurity_resetconnectionattempsvar', ResetConnectionAttempsVar, (1)).start(30, 0)

    if CFGVar('kick_clientside_addons'):
        Log(4, "Lade Anti-Clientside Addons")
        LoadCheckPlayerVars(1)

    if CFGVar('client_check_cheat_cvars'):
        ClientCVarCheck = repeat.create('servsecurity_client_cheat_cvarcheck', CheckCheatCVars, (1))
        ClientCVarCheck.start(60, 0)

    if CFGVar('crashreporter'):
        Log(4, "Aktiviere Crash-Report")
        reportfile = es.getAddonPath('servsecurity') + PS + "crashreport.txt"
        if not os.path.isfile(reportfile):
            Log(4, "Lege Crash-Reportdatei an...")
            try:
                fp = open(reportfile, 'w')
                fp.write("")
                fp.close()
            except:
                Log(1, "Unabe to create crash report file")

        tmpfile = es.getAddonPath('servsecurity') + PS + "data" + PS + "tmpcrashreport.txt"

        if os.path.isfile(tmpfile):
            crashtime = 0
            Log(4, "Lese Tempfile '" + tmpfile + "'")
            try:
                fp = open(tmpfile, 'r')
                crashtime = fp.read()
                fp.close()
            except:
                log(1, "Unabe to read crash report data")

            if crashtime and float(crashtime) > 0:
                Log(4, "Da war ein Crash, schreibe dies in Datei")
                CrashDate = Timestamp2Date(float(crashtime))
                RestartDate = Timestamp2Date(time.time())

                LogText = "Server crash detected! Server crashed at " + str(CrashDate) + ". Restarted at " + str(RestartDate)
                try:
                    fp = open(reportfile, 'a')
                    fp.writelines(LogText + Wrap)
                    fp.close()
                except:
                    Log(1, LogText)
                Statistics['ReportedCrashes'] += 1

        Log(4, "Schreibe Tempfile")
        try:
            fp = open(tmpfile, 'w')
            fp.write(str(time.time()))
            fp.close()
        except:
            Log(1, "Unabe to write crash report data")

        Log(4, "Starte Crash-Report Repeater")
        repeat.create('servsecurity_crashreporter', WriteCrashReportFile, (1)).start(2, 0)

    """
    if es.getInt('sv_allow_wait_command') != 0:
        Log(4, "Setzte sv_allow_wait_command 0")
        es.flags('add', 'notify', 'sv_allow_wait_command')
        es.server.cmd('sv_allow_wait_command 0')
        es.flags('remove', 'notify', 'sv_allow_wait_command')
    """

    if CFGVar('antinamehacks') or CFGVar('check_cvars_sv_cheats'): # or CFGVar('check_cvars_sv_allow_wait_command')
        Log(4, "Starte PlayerBackgroundThread")
        repeat.create('servsecurity_playerbackgroundthread', PlayerBackgroundThread, (1)).start(5, 0)

    repeat.create('servsecurity_QueryClientVarThreadStarter', QueryClientVarThreadStarter, (1)).start(3, 0)


    Log(4, "-> _CheckLoadServSecurity")
    _CheckLoadServSecurity(1)

    Loaded = True
    PreLoad = False


def _CheckLoadServSecurity(check):
    if check != 1:
        return

    gamethread.cancelDelayed('servsecurity_checkload')
    if es.ServerVar('eventscripts_currentmap') == "":
        Log(4, "Gamethread(1, .., _CheckLoadServSecurity, (1))")
        gamethread.delayedname(1, 'servsecurity_checkload', _CheckLoadServSecurity, (1))
    else:
        Log(4, "Gamethread(1, .., _LoadServSecurity, (1))")
        gamethread.delayedname(3, 'servsecurity_checkload', _LoadServSecurity, (1))


def _LoadServSecurity(check):
    if check != 1:
        return

    if CFGVar('protectvars') == 1:
        Log(4, "Schuetze Variabeln...")
        ServerVariables = dict(ProtectServerVars)
        for ServerVar in ServerVariables:
            if ProtectServerVars[ServerVar]['default'] == '_request_':
                if not ProtectServerVars[ServerVar].has_key('requestfile'):
                    del ProtectServerVars[ServerVar]['requestfile']
                    Log(1, "Cant protect var '" + ServerVar + "': Request file not defined")
                    continue

                File = ProtectServerVars[ServerVar]['requestfile']
                if File == "_cfgfile_":
                    File = CFGVar('file_with_server_variables', False)

                if (ProtectServerVars[ServerVar].has_key('load_removecheatflag') and ProtectServerVars[ServerVar]['load_removecheatflag']) or (ProtectServerVars[ServerVar].has_key('cheatflag') and ProtectServerVars[ServerVar]['cheatflag']):
                    es.flags('remove', 'cheat', ServerVar)

                if os.path.isfile(es.ServerVar('eventscripts_gamedir') + PS + "cfg" + PS + File) or os.path.isfile(es.ServerVar('eventscripts_gamedir') + PS + "cfg" + PS + File + ".cfg"):
                    ExecCMD("exec " + File, 0)
                else:
                    del ProtectServerVars[ServerVar]
                    Log(1,  "Unable to exec file '" + File + "' to protect var '" + ServerVar + "'")
                    continue

            if not es.exists('variable', ServerVar):
                Log(1,  "Cant protect var '" + ServerVar + "': Variable not found")
                del ProtectServerVars[ServerVar]
                continue
            elif str(es.ServerVar(ServerVar)) == "":
                Log(1,  "Cant protect var '" + ServerVar + "': Variable empty")
                del ProtectServerVars[ServerVar]
                continue
            elif str(es.ServerVar(ServerVar)) == "_request_":
                Log(1,  "Cant protect var '" + ServerVar + "': Request variable failed!")
                del ProtectServerVars[ServerVar]
                continue

            if ProtectServerVars[ServerVar]['default'] == '_request_':
                ProtectServerVars[ServerVar]['default'] = str(es.ServerVar(ServerVar))

            if es.ServerVar(ServerVar) != ProtectServerVars[ServerVar]['default']:
                es.setinfo(ServerVar, ProtectServerVars[ServerVar]['default'])
                es.forcevalue(ServerVar, ProtectServerVars[ServerVar]['default'])

            if ProtectServerVars[ServerVar].has_key('cheatflag') and ProtectServerVars[ServerVar]['cheatflag']:
                es.flags('add', 'cheat', ServerVar)
                es.flags('add', 'notify', ServerVar)

            if ProtectServerVars[ServerVar].has_key('protected') and ProtectServerVars[ServerVar]['protected']:
                es.flags('add', 'protected', ServerVar)

            Log(3, "Variable '" + ServerVar + "' protected")

        Log(4, "Starte VariableMonitoring Repeat")
        repeat.create('servsecurity_varmonitor', VariableMonitoring, (1)).start(1, 0)


def unload():
    global Loaded, _AllowUnload

    if _Password == "":
        _AllowUnload = True

    if not _AllowUnload:
        Statistics['UnauthorizedUnloads'] += 1
        _UnauthorizedUnload = True

    if not PreLoad:
        Log(4, "Dumpe servsecurity.db")
        DumpVars(1)

    if CFGVar('commandblocker') == 1:
        Log(4, "Entblocke Commands")
        for Command in CommandList:
            Flags = CommandList[Command]['flags']
            Side = CommandList[Command]['side']
            if 'rm' in Flags:
                if 'client' in Side:
                    es.unregclientcmd(Command)
                    Log(3, "Unregistered clientcommand '"+Command+"'")
            if 'bl' in Flags:
                es.flags('remove', 'cheat', Command)

    if CFGVar('protectvars') == 1:
        for ServerVar in ProtectServerVars:
            Log(4, "Entferne notify-Flag von " + ServerVar)
            es.flags('remove', 'notify', ServerVar)
            if _AllowUnload and ProtectServerVars[ServerVar].has_key('cheatflag') and ProtectServerVars[ServerVar].has_key('unload_remove_cheatflag') and ProtectServerVars[ServerVar].has_key('cheatflag') and ProtectServerVars[ServerVar].has_key('unload_remove_cheatflag'):
                es.flags('remove', 'cheat', ServerVar)
                Log(3, "Removed cheat-flag from variable '" + ServerVar + "'")

    Log(4, "Stoppe Repeats")

    repeaters = ['servsecurity_QueryClientVarThreadStarter', 'servsecurity_client_cheat_cvarcheck', 'servsecurity_playerbackgroundthread', 'servsecurity_crashreporter', 'servsecurity_resetconnectionattempsvar', 'servsecurity_miscbackground', 'servsecurity_varmonitor']
    for r in repeaters:
        try:
            repeat.find(r).stop()
        except:
            pass

    if CFGVar('crashreporter'):
        Log(4, "Stoppe Crashreport")
        tmpfile = es.getAddonPath('servsecurity') + PS + "data" + PS + "tmpcrashreport.txt"
        try:
            fp = open(tmpfile, 'w')
            fp.write(str(0))
            fp.close()
        except:
            Log(1, "Unable to write crash report data")

    if CFGVar('block_text_with_illegal_chars'):
        Log(4, "Unregistriere SayFilter")
        try:
            es.addons.unregisterSayFilter(sayFilter)
        except:
            Log(4, "SayFilter unregistrieren fehlgeschlagen")

    if not _AllowUnload:
        Log(1, "Unauthorized unload! Reload...")
        ExecCMD("es_xload servsecurity", 2)
        gamethread.delayed(0.1, es.load, ("servsecurity"))
    else:
        Loaded = False

    FlushLogs(1)
    CloseLogFile(1)

    if _AllowUnload:
        es.server.printmsg('[ServSecurity] ServSecurity unloaded! Please restart your server!')


def Username(userid):
    if not es.exists('userid', userid):
        return 'unknow'
    return str(es.getplayername(userid))


def GetSteamID(userid):
    if not es.exists('userid', userid):
        return False
    return str(es.getplayersteamid(userid))


def Clientinfo(userid):
    userid = int(userid)
    IP = "[no ip found]"
    if UserIDToIP.has_key(userid):
        IP = "[" + str(UserIDToIP[userid]) + "]"
    if not es.exists('userid', userid):
        return "userid '" + str(userid) + "' (unknow) [no steamid found] " + IP
    return "userid '" + str(userid) + "' (" + Username(userid) + ") [" + str(GetSteamID(userid)) + "] " + IP


def DownloadCheckPlayerVars(check):
    if check != 1:
        return

    Log(4, "-> RUN:DownloadCheckPlayerVars")
    threading.Thread(target=DoDownloadCheckPlayerVars, args=("1")).start()


def DoDownloadCheckPlayerVars(check):
    global CheckPlayerVarsLastDownload
    if check != 1 and check != "1":
        return

    Log(2, "Download 'PlayerCheckVars'...")
    CheckPlayerVarsLastDownload = time.time()

    socket.setdefaulttimeout(5)

    try:
        Obj = urllib.urlopen(CheckPlayerVarDownloadURL)
        Result = Obj.read()
        Obj.close()
        Log(2, "'PlayerCheckVars' downloaded")
    except:
        Log(2, "Download 'PlayerCheckVars' failed")
        return

    try:
        Path = es.getAddonPath('servsecurity') + PS + 'checkplayervars.ini'
        fp = open(Path, 'wb')
        fp.write(Result)
        fp.close()
    except:
        Log(1, "Save 'PlayerCheckVars' failed")
        return
    Log(2, "'PlayerCheckVars' data saved")
    LoadCheckPlayerVars(1)


def LoadCheckPlayerVars(check):
    global CheckPlayerVars
    if check != 1:
        return

    Log(3, "Read 'PlayerCheckVars'...")
    CheckPlayerVars = ConfigObj(es.getAddonPath('servsecurity') + PS + 'checkplayervars.ini')
    for Y in dict(CheckPlayerVars):
        for X in dict(CheckPlayerVars[Y]):
            if X in ['status','action','value']:
                CheckPlayerVars[Y][X] = list(str(CheckPlayerVars[Y][X]).split(";"))
            else:
                CheckPlayerVars[Y][X] = str(CheckPlayerVars[Y][X])


def DumpVars(check):
    if check != 1:
        return

    global LastDBWrite

    Log(4, "Dumpe Variabeln in servsecurity.db")

    File                                = es.getAddonPath('servsecurity') + PS + 'servsecurity.db'

    LastDBWrite                         = time.time()
    Data                                = {}
    Data['Statistic']                   = Statistics
    Data['GlobalIPBanList']             = GlobalIPBanList
    Data['GlobalIDBanList']             = GlobalIDBanList
    Data['GlobalBanListLastDownload']   = GlobalBanListLastDownload
    Data['CheckPlayerVarsLastDownload'] = CheckPlayerVarsLastDownload
    Data['version']                     = info.version
    Data['build']                       = info.build
    Data['UnauthorizedUnload']          = _UnauthorizedUnload
    Data['LastUpdateCheck']             = LastUpdateCheck
    Data['LastPluginCheck']             = LastPluginCheck
    Data['UniqueID']                    = UniqueID

    try:
        fp = open(File, 'wb')
        cPickle.dump(Data, fp)
        fp.close()
    except:
        Log(1, "ServSecurity: Unable to save data to servsecurity.db")
        return


def ReadVars(check):
    if check != 1:
        return

    global UniqueID

    Log(4, "Lese Variabeln aus servsecurity.db")

    File = es.getAddonPath('servsecurity') + PS + 'servsecurity.db'
    Data = {}
    if os.path.isfile(File):
        try:
            fp = open(File)
            Data = cPickle.load(fp)
            fp.close()
        except:
            Log(1, "Failed to open servsecurity.db")
            return

        if Data:
            global Statistics, GlobalIPBanList, GlobalIDBanList, GlobalBanListLastDownload, CheckPlayerVarsLastDownload, LastPluginCheck, LastUpdateCheck
            for keyname in Data['Statistic']:
                Statistics[keyname] = Data['Statistic'][keyname]
            GlobalIPBanList = Data['GlobalIPBanList']
            GlobalIDBanList = Data['GlobalIDBanList']
            GlobalBanListLastDownload = Data['GlobalBanListLastDownload']
            if Data.has_key('CheckPlayerVarsLastDownload'):
                CheckPlayerVarsLastDownload = Data['CheckPlayerVarsLastDownload']
            if Data.has_key('LastUpdateCheck'):
                LastUpdateCheck = Data['LastUpdateCheck']
            if Data.has_key('LastPluginCheck'):
                LastPluginCheck = Data['LastPluginCheck']
            if Data.has_key('UniqueID'):
                UniqueID = Data['UniqueID']

            if not Data.has_key('build') or (Data['build'] < info.build):
                OnUpdateServSecurity(1)
        else:
            OnUpdateServSecurity(1)
    else:
        OnUpdateServSecurity(1)


def OnUpdateServSecurity(check):
    if check != 1:
        return

    Log(1, "Thanks for updating to ServSecurity " + str(info.version))


def OpenLogfile(check):
    if check != 1:
        return

    global LogfilePointer
    LogfilePointer = False

    if CFGVar('logtype') in [2,3]:
        if not CFGVar('one_logfile'):
            now = datetime.datetime.now()
            if CFGVar('timeformat') == 1:
                FileName = now.strftime("%m-%d-%Y")
            elif CFGVar('timeformat') == 3:
                FileName = now.strftime("%Y-%m-%d")
            else:
                FileName = now.strftime("%d.%m.%Y")

            LogFile = es.getAddonPath('servsecurity') + PS + "logs" + PS + "ServSecurity_Log_" + str(FileName) + ".txt"
        else:
            LogFile = es.getAddonPath('servsecurity') + PS + "logs" + PS + "ServSecurity_Log.txt"

        if not os.path.isfile(LogFile):
            try:
                fp = open(LogFile, 'wb')
                fp.writelines("#### To report suspicious activities send your server and ServSecurity logs to report@servsecurity.com ####" + Wrap)
                fp.close()
            except:
                Log(1, "ServSecurity: Unable to write file '" + LogFile + "' (no permissions?)")

        try:
            LogfilePointer = open(LogFile, 'ab')
        except:
            Log(1, "ServSecurity: Unable to write file '" + LogFile + "' (no permissions?)")


def CloseLogFile(check):
    if check != 1:
        return

    global LogfilePointer
    if LogfilePointer:
        try:
            LogfilePointer.close()
        except:
            es.log("ServSecurity: Unable to close log file")

        LogfilePointer = False


def ShowStats():
    Log(4, "Sende Statistiken...")

    es.server.printmsg("=============================")
    es.server.printmsg("ServSecurity " + str(info.version) + " statistics")
    es.server.printmsg("=============================")
    for Stat in StatisticsTextOrder:
        if not Statistics.has_key(Stat):
            Log(3, "'" + Stat + "' not found in Statistics...")
            continue
        Output = ""
        if StatisticsText.has_key(Stat):
            Output += StatisticsText[Stat]
        else:
            Output += Stat
        Output += ": " + str(Statistics[Stat])
        es.server.printmsg(Output)


def Timestamp2Date(t_timestamp):
    try:
        date = datetime.datetime.fromtimestamp(t_timestamp)

        if CFGVar('timeformat') == 1:
            return str(date.strftime("%m/%d/%Y %H:%M:%S"))
        elif CFGVar('timeformat') == 3:
            return str(date.strftime("%Y-%m-%d %H:%M:%S"))
        else:
            return str(date.strftime("%d.%m.%Y %H:%M:%S"))
    except:
        return ""


def CheckPlugins():
    if not Loaded:
        es.server.printmsg('ServSecurity not loaded')
        return

    global LastPluginCheck
    LastPluginCheck = time.time()

    Log(1, "Get plugin-list...")
    threading.Thread(target=GetPluginList, args=("1")).start()


def GetPluginList(check):
    if check != 1 and check != "1":
        return

    socket.setdefaulttimeout(5)

    Log(4, "-> RUN:GetPluginList")

    try:
        Obj = urllib.urlopen(PluginVerURL)
        Result = Obj.read()
        Obj.close()

        File = es.getAddonPath('servsecurity') + PS + "plugins.ini"

        Log(4, "Writing to '" + File + "'...")

        fp = open(File, 'wb')
        fp.write(Result)
        fp.close()
    except:
        Log(2, "Plugin-Check failed")
        return


    PluginData = ConfigObj(File)
    for PluginVar in PluginData:
        Pluginname = str(PluginData[PluginVar]['pluginname'])
        PluginHP = str(PluginData[PluginVar]['homepage'])
        Versions = PluginData[PluginVar]['version'].split("||")

        if es.exists('variable', PluginVar) and not es.ServerVar(PluginVar)  == "0":
            ServerVersion = str(es.ServerVar(PluginVar))
            Log(4, "PluginCheck: '" + PluginVar + "' found ('" + ServerVersion + "')")
            if not ServerVersion in Versions:
                if len(Versions) > 1:
                    PluginVers = "versions are '" + "', '".join(Versions) + "'"
                else:
                    PluginVers = "version is '" + str(PluginData[PluginVar]['version']) + "'"
                Log(1, "Your '" + Pluginname + "' is out of date! Current " + PluginVers + ". Installed on your server: '" + es.ServerVar(PluginVar) + "' - Download-Homepage: " + PluginHP)

    Log(3, "Plugin-Check finished")


def DownloadBanLists(check):
    if check != 1:
        return

    if not Loaded:
        es.server.printmsg('ServSecurity not loaded')
        return

    global GlobalBanListLastDownload
    GlobalBanListLastDownload = time.time()

    Log(1, "Get global banlists...")

    threading.Thread(target=DownloadGlobalIPList, args=("1")).start()
    threading.Thread(target=DownloadGlobalIDList, args=("1")).start()

    return


def DownloadGlobalIPList(check):
    if check != 1 and check != "1":
        return

    global GlobalIPBanList

    if not CFGVar('use_global_ipbanlist'):
        return

    socket.setdefaulttimeout(5)
    Log(1, "Download global IP banlist...")

    try:
        Obj = urllib.urlopen(GlobalIPList)
        Result = Obj.read()
        Obj.close()
    except:
        Log(1, "Downloading global IP banlist failed (no connection)")
        return

    if not Result.startswith("ServSecurity") or not Result.endswith("ServSecurity"):
        Log(1, "Downloading global IP banlist failed (verification error)")
        return

    if Result[12:-12] != "":
        GlobalIPBanList = Result[12:-12].split("|")
    else:
        GlobalIPBanList = []
    Log(1, "Downloading global IP banlist successfully! '%s' entries" % len(GlobalIPBanList))


def DownloadGlobalIDList(check):
    if check != 1 and check != "1":
        return

    global GlobalIDBanList

    if not CFGVar('use_global_idbanlist'):
        return

    socket.setdefaulttimeout(5)
    Log(1, "Download global Steam-ID banlist...")

    try:
        Obj = urllib.urlopen(GlobalIDList)
        Result = Obj.read()
        Obj.close()
    except:
        Log(1, "Downloading global Steam-ID banlist failed (no connection)")
        return

    if not Result.startswith("ServSecurity") or not Result.endswith("ServSecurity"):
        Log(1, "Downloading global Steam-ID banlist failed (verification error)")
        return

    if Result[12:-12] != "":
        GlobalIDBanList = Result[12:-12].split("|")
    else:
        GlobalIDBanList = []
    Log(1, "Downloading global Steam-ID banlist successfully! '%s' entries" % len(GlobalIDBanList))


def WriteCrashReportFile(check):
    if check != 1:
        return

    Log(4, "-> RUN: WriteCrashReportFile")

    try:
        tmpfile = es.getAddonPath('servsecurity') + PS + "data" + PS + "tmpcrashreport.txt"
        fp = open(tmpfile, 'w')
        fp.write(str(time.time()))
        fp.close()
    except:
        Log(2, "Cant write to " + str(tmpfile))
        return


def PlayerBackgroundThread(check):
    if check != 1:
        es.server.printmsg("Check failed")
        return

    Log(4, "-> RUN: PlayerBackgroundThread")

    for userid in es.getUseridList():
        if CFGVar('antinamehacks'):
            QueryClientVar(userid, "name")
        if CFGVar('check_cvars_sv_cheats'):
            QueryClientVar(userid, "sv_cheats")
        #if CFGVar('check_cvars_sv_allow_wait_command'):
            #QueryClientVar(userid, "sv_allow_wait_command")


def CheckCheatCVars(check, x):
    if check != 1:
        return

    if CFGVar('client_check_cheat_cvars'):
        for userid in es.getUseridList():
            for VarName in ClientCheckCheatCVars:
                QueryClientVar(userid, VarName)


def MiscBackground(check):
    if check != 1:
        return


    Log(4, "-> RUN: MiscBackground")

    if GlobalBanListLastDownload < (time.time()-(3600*24)):
        DownloadBanLists(1)

    if CheckPlayerVarsLastDownload < (time.time()-(3600*24)):
        DownloadCheckPlayerVars(1)

    if LastDBWrite < (time.time()-60):
        DumpVars(1)

    if LastUpdateCheck < (time.time()-(3600*24)):
        Check4Updates()

    if LastPluginCheck < (time.time()-(3600*24)):
        CheckPlugins()

    FlushLogs(1)


def UnloadMe():
    global _AllowUnload
    if not Loaded and not PreLoad:
        es.server.printmsg('ServSecurity not loaded')
        return

    Log(4, "-> CALL: UnloadMe")

    ArgPass = es.getargv(1)
    if _Password == ArgPass:
        _AllowUnload = True
        ExecCMD("es_xunload servsecurity", 2)
    else:
        Log(1, "Invalid ServSecurity password! Unload failed!")


def SetServSecurityPassword():
    ArgPass = es.getargv(1)
    SetPasswd(ArgPass)


def SetPassword():
    ArgPass = es.getargv(1)
    SetPasswd(ArgPass)


def SetPasswd(ArgPass):
    global _Password
    if Loaded or not PreLoad:
        Log(1, "ServSecurity already loaded! Cant set password")
        return

    if len(ArgPass) < 6:
        Log(1, "Cant set ServSecurity password: Password is too short")
    else:
        _Password = ArgPass
        Log(1, "ServSecurity password set")


def player_disconnect_pre(event_var):
    if len(event_var['reason']) > 255:
        BanID(event_var['networkid'], "Too long disconnect message: " + len(event_var['reason']), 4)
    event_var['reason'] = "Disconnect"
    return event_var


def player_disconnect(ev):
    userid = int(ev['userid'])
    if IllegalCharCount.has_key(userid):
        del IllegalCharCount[userid]
    if UserIDToIP.has_key(userid):
        del UserIDToIP[userid]
    if userid in BlockNotBanUserIDs:
        BlockNotBanUserIDs.remove(userid)
    if PlayerNames.has_key(userid):
        del PlayerNames[userid]
    if PlayerQueryClientValues.has_key(userid):
        del PlayerQueryClientValues[userid]


def round_start(ev):
    DisableRCONCrashExploit(1)


def Check4Updates():
    if not Loaded:
        es.server.printmsg("ServSecurity Check4Updates() FAILED! ServSecurity is not loaded!")
        return

    global LastUpdateCheck
    if (time.time() - LastUpdateCheck) < 20:
        return

    Log(4, "-> update.Check4Updates()")
    LastUpdateCheck = float(time.time())
    update.Check4Updates()


def ForceUpdate():
    if not Loaded:
        es.server.printmsg("ServSecurity ForceUpdate() FAILED! ServSecurity is not loaded!")
        return

    global LastUpdateCheck
    if (time.time() - LastUpdateCheck) < 20:
        return

    Log(4, "-> update.ForceUpdate()")
    LastUpdateCheck = float(time.time())
    update.ForceUpdate()


def es_player_variable(ev):
    if not es.exists('userid', ev['userid']):
        return

    userid = int(ev['userid'])
    if PlayerQueryClientValues.has_key(userid) and PlayerQueryClientValues[userid].has_key(ev['variable']):
        del PlayerQueryClientValues[userid][ev['variable']]

    Vars = ['name','sv_cheats'] #,'sv_allow_wait_command'
    VarName = ev['variable'].lower()
    if ev['status'] != "success" and VarName in Vars:
        Kick(userid, "CVar request failed! Please restart your game!", False, 3)
        Log(2, "Player %s kicked because cvar '%s' request failed" % (Clientinfo(userid), VarName))
        return

    if CFGVar('antinamehacks') and VarName == 'name' and PlayerNames.has_key(userid) and PlayerNames[userid] != MD5(ev['value']):
        Kick(userid, "Namehack detected!", False, 3)
        return
    elif VarName == 'sv_cheats' and CFGVar('check_cvars_sv_cheats'):
        try:
            Value = int(ev['value'])
        except:
            Value = 1

        if Value != 0 and not es.getInt('sv_cheats') == 1:
            Log(2, "Player " + Clientinfo(userid) + " banned for sv_cheats bypass!")
            steamid = GetSteamID(userid)
            if steamid:
                BanID(steamid, "sv_cheats bypass", 3)
            Kick(userid, "sv_cheats bypass!", False, 3)
        return
    """
    elif VarName == 'sv_allow_wait_command' and CFGVar('check_cvars_sv_allow_wait_command'):
        try:
            Value = int(ev['value'])
        except:
            Value = 1
        if Value != 0 and not es.getInt('sv_allow_wait_command') == 1:
            Log(2, "Player " + Clientinfo(userid) + " kicked for sv_allow_wait_command bypass!")
            Kick(userid, "sv_allow_wait_command bypass!", False, 3)
        return
    """
    if ClientCheckCheatCVars.has_key(VarName) and es.getInt('sv_cheats') == 0:
        if ev['status'] != "success":
            Log(2, "Player %s kicked because cvar '%s' request failed" % (Clientinfo(userid), VarName))
            Kick(userid, "CVar request failed! Please restart your game!",False, 3)
            return
        Value2 = ClientCheckCheatCVars[VarName]
        if isinstance(Value2, int):
            try:
                Value = int(ev['value'])
            except:
                Kick(userid, "Invalid cvar response!", False, 3)
                return
        elif isinstance(Value2, float):
            try:
                Value = float(ev['value'])
            except:
                Kick(userid, "Invalid cvar response!", False, 3)
                return
        if Value != Value2:
            steamid = es.getplayersteamid(userid)
            BanID(steamid, "CVar cheat %s bypass" % VarName)
            Kick(userid, "Cheat cvar bypass", False, 3)
            Log(2, "Player %s kicked for cvar '%s' bypass" % (Clientinfo(userid), VarName))
        return


    if not CFGVar('kick_clientside_addons'):
        return

    if CheckPlayerVars.has_key(ev['variable']) and ev['status'] in CheckPlayerVars[ev['variable']]['status']:
        Data = CheckPlayerVars[ev['variable']]
        if "-1" in Data['value'] or ev['value'] in Data['value']:
            if "ban" in Data['action']:
                steamid = GetSteamID(userid)
                if steamid:
                    BanID(steamid, Data['desc'], 3)
            if "kick" in Data['action']:
                Kick(ev['userid'], Data['message'], 3)
                Log(2, "Kicked " + Clientinfo(userid) + " for '" + str(Data['desc']) + "'")
            if "message" in Data['action']:
                es.tell(userid, "#multi", Data['message'])


def SubmitSteamID(steamid, msg):
    if CFGVar('allow_steamid_submit'):
        # Submit Steam-ID to ServSecurity Team for validation
        Log(4, "-> RUN: SubmitSteamID(%s, %s)" % (steamid, msg))

        URL = ReportURL+"?"+urllib.urlencode({'u':UniqueID,'s':steamid,'m':msg})+"&v="+MD5(UniqueID+"*"+steamid+"*"+msg)
        try:
            Obj = urllib.urlopen(URL)
            Obj.close()
        except:
            return


def SetVariables(check):
    if check != 1:
        return

    global CheckPlayerVars, GlobalIDBanList, GlobalIPBanList, Kicked, PlayerNames, ConnectionAttemps, IllegalCharCount, UserIDToIP, PlayerQueryClientValues, BlockNotBanUserIDs

    if not PreLoad:
        DumpVars(1)

    CheckPlayerVars         = {}
    GlobalIDBanList         = []
    GlobalIPBanList         = []
    Kicked                  = []
    BlockNotBanUserIDs      = []
    PlayerNames             = {}
    ConnectionAttemps       = {}
    IllegalCharCount        = {}
    UserIDToIP              = {}
    PlayerQueryClientValues = {}

    if not PreLoad:
        ReadVars(1)


def es_map_start(ev):
    SetVariables(1)


def player_activate(ev):
    userid = int(ev['userid'])
    if CFGVar('use_global_idbanlist') and ev['es_steamid'] in GlobalIDBanList:
        if UserIDToIP.has_key(userid):
            IP = UserIDToIP[userid]
        else:
            IP = 'none'
        Kick(userid, "Your Steam-ID is in the global ServSecurity banlist", IP, 3)
        Log(2, "Player %s kicked because his Steam-ID is in the global ServSecurity banlist" % (Clientinfo(userid)))
        Statistics['GlobalBannedIDs'] += 1
        return
    if CFGVar('steamid_pending_kick') and ev['es_steamid'].lower() == "steam_id_pending":
        gamethread.delayed(CFGVar('steamid_pending_kick_time'), CheckPlayerSteamID, (userid))
    if CFGVar('message_on_connect'):
        es.tell(userid, "#multi", "#default Server protected by#lightgreen ServSecurity %s#default developed by#green Dark Session" % info.version)
    if CFGVar('kick_unassigned'):
        gamethread.delayed(15, ForceTeam, (userid))

    if CFGVar('kick_clientside_addons'):
        for Variable in CheckPlayerVars:
            QueryClientVar(userid, Variable)

    if not userid in BlockNotBanUserIDs:
        BlockNotBanUserIDs.append(userid)

    if CFGVar('antinamehacks') and not es.isbot(userid) and ev['es_steamid'].lower() != "bot":
        PlayerName = es.getclientvar(userid, "name")
        if PlayerName:
            PlayerNames[userid] = MD5(str(PlayerName))
        else:
            PlayerNames[userid] = MD5(ev['es_username'])


def QueryClientVar(userid, VarName):
    if not es.exists('userid', userid) or es.isbot(userid) or GetSteamID(userid).lower() == "bot":
        return

    userid = int(userid)
    if not PlayerQueryClientValues.has_key(userid):
        PlayerQueryClientValues[userid] = {}

    if not PlayerQueryClientValues[userid].has_key(VarName):
        PlayerQueryClientValues[userid][VarName]                = {}
        PlayerQueryClientValues[userid][VarName]['requesttime'] = float(time.time())
        PlayerQueryClientValues[userid][VarName]['querytime']   = float(0)
        PlayerQueryClientValues[userid][VarName]['queried']    = False


def QueryClientVarThreadStarter(check, x):
    if check != 1:
        return

    Log(4, "-> RUN: QueryClientVarThreadStarter")

    threading.Thread(target=QueryClientVarThreadRun, args=("1")).start()


def QueryClientVarThreadRun(check):
    global QueryClientVarThreadRunning
    if check != 1 and check != "1":
        return

    if not QueryClientVarThreadRunning:
        QueryClientVarThreadRunning = True
        try:
            Log(4, "Starte QueryClientVarThread")
            QueryClientVarThread(1)
        except:
            pass
        QueryClientVarThreadRunning = False
    else:
        Log(4, "QueryClientVarThread: Already running")


def QueryClientVarThread(check):
    if check != 1:
        return

    for userid in dict(PlayerQueryClientValues):
        if not es.exists('userid', userid):
            del PlayerQueryClientValues[userid]
            continue

        for VarName in dict(PlayerQueryClientValues[userid]):

            if not PlayerQueryClientValues[userid][VarName]['queried']:
                Log(4, "Query %s client value '%s'" % (Clientinfo(userid), VarName))
                PlayerQueryClientValues[userid][VarName]['queried'] = True
                PlayerQueryClientValues[userid][VarName]['querytime'] = float(time.time())
                es.queryclientvar(userid, VarName)
            else:
                Now = float(time.time())
                if (Now - PlayerQueryClientValues[userid][VarName]['querytime']) > es.getInt('sv_timeout')+1:
                    Log(2, "Failed to query %s cvar" % (Clientinfo(userid)))
                    Kick(userid, "Failed to query a cvar! Please restart your game!", False, 3)
                    del PlayerQueryClientValues[userid][VarName]
                    break

        time.sleep(0.5)


def ForceTeam(userid):
    if not es.exists('userid', userid) or es.isbot(userid):
        return

    Log(4, "-> RUN: ForceTeam(%s)" % userid)

    if not int(es.getplayerteam(userid)) in range(1,4):
        ExecCMD("es_xchangeteam %s 1" % userid, 2)
        Log(3, "Forced %s to join spectactors" % Clientinfo(userid))


def CheckPlayerSteamID(userid):
    if not es.exists('userid', userid):
        return

    Log(4, "-> RUN: CheckPlayerSteamID(%s)" % userid)

    steamid = GetSteamID(userid)
    if steamid.lower() == "steam_id_pending":
        username = Username(userid)
        Kick(userid, "Your Steam-ID is still pending, please try again", 2)
        Log(3, "Player '" + username + "' was kicked because his Steam-ID wasn't validated")


def ResetConnectionAttempsVar(check):
    if check != 1:
        return

    global ConnectionAttemps

    if len(ConnectionAttemps):
        ConnectionAttemps = {}
        Log(3, "Connection attempts have been reset")


def bannedservercmd():
    userid = int(es.getcmduserid())
    if userid > 0 and es.exists('userid', userid):
        Kick(es.getcmduserid(), "Kicked for sending banned commands to server")
        Log(1, "Blocked: command '" + str(es.getargv(0)) + "' from " + Clientinfo(userid))
    else:
        Log(1, "Blocked: command '" + str(es.getargv(0)) + "' from console")
    Statistics['BlockedCommandExecution'] += 1
    return


def player_team(ev):
    if not es.exists('userid', ev['userid']) or ev["disconnect"] == "1":
        return

    if not int(ev['team']) in range(1,4):
        Log(1, "Kicked " + Clientinfo(ev['userid']) + " for using the unassigned exploit", 3)
        Kick(ev['userid'], "Detected: Unassigned exploit", 3)


def DisableRCONCrashExploit(check):
    if check != 1:
        return

    Log(4, "-> RUN: DisableRCONCrashExploit")

    es.forcevalue('sv_rcon_minfailures', 99999999)
    es.forcevalue('sv_rcon_maxfailures', 99999999)
    es.forcevalue('sv_rcon_minfailuretime', 1)
    Log(4, "RCON crash exploit disabled")


def sayFilter(userid, text, teamonly):
    userid = int(userid)
    if not es.exists('userid', userid) and userid != -1:
        Log(2, "Blocked text from not ingame " + Clientinfo(userid))
        Statistics['BlockedText'] += 1
        if not userid in BlockNotBanUserIDs and userid in UserIDToIP:
            Kick(userid, "Kicked for using the console say exploit", UserIDToIP[userid])
        return (0,0,0)

    if not CheckCharacters(text):
        Statistics['BlockedText'] += 1
        if not IllegalCharCount.has_key(userid):
            IllegalCharCount[userid] = 0
        IllegalCharCount[userid] += 1
        Playername = Username(userid)
        if IllegalCharCount[userid] >= CFGVar('illegal_chars_max_tries'):
            ip = False
            if UserIDToIP.has_key(userid):
                ip = UserIDToIP[userid]
            Kick(userid, "Kicked and banned for using illegal characters in your messages!", ip)
            Steamid = GetSteamID(userid)
            if Steamid:
                BanID(Steamid, "Illegal message characters", 3)
            Log(1, "Kicked and banned " + Clientinfo(userid) + " for using illegal characters in his messages")
        else:
            Log(2, "Blocked text from " + Clientinfo(userid) + " which contains illegal chars")
            es.tell(userid, "#multi", "#green [ServSecurity]#default Text blocked! Stop using illegal characters!")

        Statistics['BlockedText'] += 1
        return (0,0,0)

    return (userid, text, teamonly)


def Log(level, text):
    global TempLogWrite

    if level > CFGVar('loglevel'):
        return

    Lev = "unknow"
    level = int(level)

    if level == 1:
        Lev = "Important  "
    elif level == 2:
        Lev = "Warning    "
    elif level == 3:
        Lev = "Information"
    elif level == 4:
        Lev = "DEBUG      "

    LogText = "[ServSecurity " + Timestamp2Date(time.time()) + "] [%s] %s" % (Lev, text)

    if CFGVar('logtype') in [1,3]:
        if len(LogText) > 1024:
            LogText = LogText[0:1023]
        es.log(LogText)
    if CFGVar('logtype') in [2,3]:
        TempLogWrite += LogText + Wrap
        if PreLoad:
            es.server.printmsg(LogText)

    if len(TempLogWrite) >= LogWriteLimit:
        FlushLogs(1)


def FlushLogs(check):
    if check != 1:
        return

    global TempLogWrite

    if len(TempLogWrite) <= 0:
        return

    OpenLogfile(1)

    try:
        LogfilePointer.writelines(TempLogWrite)
    except:
        TempLogWrite = ""
        es.log("ServSecurity: Unable to flush log data")
        try:
            CloseLogFile(1)
        except:
            pass
        return

    TempLogWrite = ""
    CloseLogFile(1)


def CFGVar(name, returnType = 'int'):
    if Config.has_key(name):
        if returnType == "int":
            return int(Config[name])
        elif returnType == "float":
            return float(Config[name])
        return str(Config[name])
    return ""


def player_connect(ev):
    userid = int(ev['userid'])
    IP = ev["address"].split(":")[0]
    UserIDToIP[userid] = IP

    if CFGVar('antinamehacks'):
        PlayerNames[userid] = MD5(ev["name"])

    if ev["networkid"] in ConnectWhitelist or IP in IPWhitelist:
        Log(3, "Player '%s' with ip '%s' is in whitelist" % (ev["name"], IP))
        return

    if CFGVar('use_global_ipbanlist') and IP in GlobalIPBanList:
        Kick(userid, "Your IP is in the global banlist of ServSecurity", IP, 3)
        Log(2, "Player '" + str(ev["name"]) + "' kicked because his IP is in the global banlist of ServSecurity")
        Statistics['GlobalBannedIPs'] += 1
        return

    if CFGVar('block_connection_spam'):
        if not IP in ConnectionAttemps:
            ConnectionAttemps[IP] = 0

        ConnectionAttemps[IP] += 1
        Log(3, "Player userid '%s' ('%s') connected with ip '%s' (attemp number %s)" % (userid, ev["name"], IP, ConnectionAttemps[IP]))

        if CFGVar('maxconnectionsperip') <= ConnectionAttemps[IP]:
            Kick(userid, "Too many connection attemps", IP)
            Log(2, "Player '" + str(ev["name"]) + "' kicked for too many connection attemps")
            Statistics['BlockedConnectionFlooders'] += 1
            return

    CheckUsername(userid, ev['name'], IP)


def player_changename(ev):
    if not es.exists('userid', ev['userid']):
        return

    userid = int(ev['userid'])
    username = ev["newname"]
    steamid = ev["es_steamid"]

    ip = False
    if UserIDToIP.has_key(userid):
        ip = UserIDToIP[userid]
    if not CheckUsername(userid, username, ip):
        BanID(steamid, "Bad username", 3)
        return

    PlayerNames[userid] = MD5(username)


def CheckUsername(userid, username, ip = False):
    if not CFGVar('block_usernames'):
        return True

    Log(4, "-> CALL: CheckUsername(%s, %s, %s)" % (userid, username, ip))

    if len(username) > MaxUsernameLength:
        Kick(userid, "Your username is too long!", ip, 3)
        Log(2, "Player '%s...' kicked for using a too long username" % username[0:MaxUsernameLength])
        Statistics['BlockedUsernames'] += 1
        return False
    elif len(username) <= 1:
        Kick(userid, "Name bypass exploit", ip, 3)
        Log(2, "Player '%s' kicked for name bypass exploit" % username)
        Statistics['BlockedUsernames'] += 1
        return True
    elif len(username.replace(" ", "")) < CFGVar('min_username_length'):
        Kick(userid, "Your username is too short!", False, 3)
        Log(2, "Player '%s' kicked for using a too short username" % username)
        Statistics['BlockedUsernames'] += 1
        return True
    elif not CheckCharacters(username):
        Kick(userid, "Your username contains illegal characters", ip, 3)
        Log(2, "Player '%s' kicked for using illegal characters" % username)
        Statistics['BlockedUsernames'] += 1
        return False
    elif username in ForbiddenUsernames or (CFGVar('kick_unnamed') and username.lower() == "unnamed"):
        Kick(userid, "Use a REAL name", 3)
        Log(2, "Player '%s' kicked for using a forbidden username" % username)
        Statistics['BlockedUsernames'] += 1
        return False
    return True


def CheckCharacters(string):
    for ForbiddenChar in ForbiddenChars:
        if ForbiddenChar in string:
            return False

    if '\x00' in string:
        return False
    return True


def VariableMonitoring(check):
    if check != 1:
        return

    Log(4, "-> RUN: VariableMonitoring")

    for ServerVar in ProtectServerVars:
        Value = es.getString(ServerVar)
        if Value != ProtectServerVars[ServerVar]['default']:
            if ProtectServerVars[ServerVar].has_key('ignoreempty') and ProtectServerVars[ServerVar]['ignoreempty'] and Value == "":
                continue

            es.forcevalue(ServerVar, ProtectServerVars[ServerVar]['default'])
            Default = str(ProtectServerVars[ServerVar]['default'])
            if ProtectServerVars[ServerVar].has_key('hidevalue') and ProtectServerVars[ServerVar]['hidevalue']:
                Default = "(***PROTECTED***)"

            LogLevel = 2
            if ProtectServerVars[ServerVar].has_key('loglevel'):
                LogLevel = ProtectServerVars[ServerVar]['loglevel']
            Log(LogLevel, "Variable '" + str(ServerVar) + "' was changed to '" + Value + "', forced back to '" +  Default + "'")

            Statistics['ResettedVariables'] += 1


def server_cvar(ev):
    var = ev["cvarname"]
    if ProtectServerVars.has_key(var):
        value = str(es.ServerVar(var))
        if ProtectServerVars[var]['default'] != value:
            es.forcevalue(var, ProtectServerVars[var]['default'])
            Default = str(ProtectServerVars[var]['default'])
            if ProtectServerVars[var].has_key('hidevalue') and ProtectServerVars[var]['hidevalue']:
                Default = "(***PROTECTED***)"
            Log(2, "Variable '" + str(var) + "' was changed to '" + value + "', forced back to '" +  Default + "'")
            Statistics['ResettedVariables'] += 1


def Kick(userid, reason, ip = False, priority = 1):
    userid = int(userid)
    if userid in Kicked:
        return

    Kicked.append(userid)

    Log(4, "-> RUN: Kick(%s, %s, %s, %s)" % (userid, reason, ip, priority))

    Statistics['KickedUsers'] += 1

    #CMD = "kickid %i [ServSecurity] %s" % (userid, reason)
    CMD = "kickid %i %s" % (userid, reason)
    ExecCMD(CMD, priority)

    if ip:
        BanIP(ip, 2)


def ExecCMD(cmd, priority = 1):
    if len(cmd) >= 1024:
        Log(2, "ExecCMD FAILED! Too long command: " + cmd)
        return False
    Log(4, "Execute command '" + cmd + "' (priority " + str(priority) + ")")
    priority = int(priority)
    if priority <= 0:
        es.server.cmd(cmd)
    elif priority == 1:
        es.server.insertcmd(cmd)
    elif priority > 2:
        gamethread.delayed(0.2, ExecCMD, (cmd, 2))
    else:
        es.server.queuecmd(cmd)
    return True


def BanID(steamid, reason="Banned by ServSecurity", priority = 1):
    Log(4, "-> RUN: BanID(%s, %s, %s)" % (steamid, reason, priority))
    if steamid and not steamid.lower() in ['bot', 'steam_id_pending'] and steamid.lower().startswith('steam_'):
        Command = CFGVar('bancommand', 'string').replace("$length", CFGVar('steamidbantime', False)).replace("$steamid", steamid).replace("$reason", '"' + reason + '"').replace("$q_steamid", '"' + steamid + '"')

        Log(4, "Using command '" + Command + "' to ban...")

        ExecCMD(Command, priority)

        Log(3, "Steam-ID '%s' banned for '%s' minutes" % (steamid, CFGVar('steamidbantime')))
        Statistics['BannedIDs'] += 1

        threading.Thread(target=SubmitSteamID, args=(str(steamid), str(reason))).start()


def BanIP(ip, priority = 1):
    Log(4, "-> RUN: BanIP(%s, %s)" % (ip, priority))
    if ip and ip.lower() != "none" and not ip.lower() in IPWhitelist:
        CMD = "addip %i %s" % (CFGVar('ipbantime'), ip)
        ExecCMD(CMD, priority)
        Log(3, "IP '%s' banned for '%s' minutes" % (ip, CFGVar('ipbantime')))
        Statistics['BannedIPs'] += 1


def md5_file(f):
    Log(4, "-> RUN: md5_file(%s)" % f)

    try:
        fp = open(f, 'rb')
        md5 = hashlib.md5()
        while True:
            data = fp.read(2**20)
            if not data:
                break
            md5.update(data)
        fp.close()
        return str(md5.hexdigest())
    except:
        Log(1, "Unable to create md5 hash from file '" + f + "'")
        return False


def MD5(string):
    return str(hashlib.md5(string).hexdigest())

#################### End of file ########################